package WordNet::IO;

use 5.006;
use strict;
use warnings;

require Exporter;

our @ISA = qw(Exporter);
our (%EXPORT_TAGS, @EXPORT_OK, @EXPORT);
%EXPORT_TAGS = @EXPORT_OK = @EXPORT = ();
our $VERSION = '0.01';

sub new {
    my $class = shift;
    my $ref = { @_, class => $class };
    return bless $ref, $class;
}

sub unimplemented {
    my ($name, $optional) = @_;
    return sub {
        my $self = shift;
        warn "$self->{class} doesn't implement $name".($optional?' (an optional function)':'').".\n";
        undef;
    }
}

NO_STRICT: {
    no strict 'refs';
    foreach my $sub (qw/read write
                     id id_by_sk id_by_qd id_all
                     is_word search iterator parent_ss
					 filenames/) {
        *$sub = unimplemented $sub;
    }
    foreach my $sub (qw/count sensenumber sentenceids sentences/) {
        *$sub = unimplemented $sub, 1;
    }
}

sub follow_pointer {
    my $self = shift;
    my ($object, $ptr_type, $count) = @_;
    $ptr_type = qr/.*/ if not $ptr_type;
    $ptr_type = qr/\Q$ptr_type\E/ if ref $ptr_type ne 'Regexp';
    $count = 1 if not defined $count or $count < 0 or not $count;
    foreach my $ptr ($object->pointers) {
        if ($ptr->type =~ $ptr_type) {
            $count--;
            return $self->read($ptr->target) unless $count;
        }
    }
    return undef;
}

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

WordNet::IO - Perl extension for blah blah blah

=head1 SYNOPSIS

  use WordNet::IO;
  blah blah blah

=head1 ABSTRACT

  This should be the abstract for WordNet::IO.
  The abstract is used when making PPD (Perl Package Description) files.
  If you don't want an ABSTRACT you should also edit Makefile.PL to
  remove the ABSTRACT_FROM option.

=head1 DESCRIPTION

Stub documentation for WordNet::IO, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Mention other useful documentation such as the documentation of
related modules or operating system documentation (such as man pages
in UNIX), or any relevant external documentation such as RFCs or
standards.

If you have a mailing list set up for your module, mention it here.

If you have a web site set up for your module, mention it here.

=head1 AUTHOR

Ben Haskell, E<lt>bhaskell@localdomainE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2003 by Ben Haskell

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
