#!/usr/local/bin/perl -T

use strict;
use warnings;
use CGI qw/:standard *ol *ul/;
$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads

print header,
    start_html(-title=>'WordNet Search Help'),
    h2('WordNet Search Help');

print a({href=>'search.pl'}, 'Main Search'),
    ' - ',
    a({href=>'advanced.pl'}, 'Advanced Search'),
    ' - ',
    a({href=>'http://wordnet.princeton.edu/~wn/man/wngloss.7WN.html'},
      "Glossary");

print h3(u('Table of Contents')),
    start_ol,
    li(a({href=>'help.pl#Search'}, 'Using the Search Page')),
    li(a({href=>'help.pl#Advanced'}, 'Using the Advanced Search Page')),
    end_ol,
    p;

print a({name=>'Search'}, ''),
    h3('Using the Search Page'),
    p('Begin a new search by typing a word or phrase into the text field '
      . 'and then clicking "Submit Query" or pressing Return.'),
    p("Navigate the results by clicking on the various links:"),
    start_ul,
    li("For a synset, clicking \"S\" will show the relations "
       . "for that synset, and clicking any of the synset's words will "
       . "begin a new search using that word alone."),
    li("Similarly, for a word, \"W\" links to the relevant relations, "
       . "and clicking the word itself begins a new search."),
    li("To explore a particular relation, click on the relation to display "
       . "the associated synsets or words."),
    li("Many synsets allow you to run extended searches on the "
       . "basic relations."),
    start_ul,
    li("For example, in addition to being able to search "
       . "for direct hypernyms of a synset, you may also search for "
       . "inherited hypernyms and coordinate terms."),
    li("When you run these extended searches, they will display the new "
       . "synsets but hide the connecting relations.  To reveal hidden "
       . "relations for a synset, click on the synset's \"S\" link."),
    end_ul,
    li("If a link has been expanded (i.e. it has sub-lists), clicking "
       . "the link will collapse the sub-lists as long as the link is not "
       . "that of a synset with hidden relations."),
    end_ul;

print a({name=>'Advanced'}, ''),
    h3('Using the Advanced Search Page'),
    p("Limit your search by selecting at least one relation."),
    start_ul,
    li("If, for example, you select \"antonyms,\" the results will all "
       . "have antonyms. If you also enter \"fast\" in the associated "
       . "text field, the results will all have \"fast\" as an antonym."),
    li("Note that you do not need to enter a value in the text field, "
       . "although that will help limit the results."),
    end_ul,
    p("Several values for the same relation may be ANDed together by "
      . "selecting that relation and giving it different text values "
      . "on separate lines on the search page. However, the words and "
      . "gloss options may not be ANDed together with themselves."),
    p("Click a Synset or Word in the results to search for it using the "
      . "Main Search Page."),
    p("If your original search returns only a few results, the search will "
      . "automatically run again without using the bottommost criterion. "
      . "The new results from the second search will appear after the "
      . "results from the original search. Therefore, try to put the most "
      . "important search criteria towards the top of the list."),
    end_ul;

print end_html;
